package eval;

import oops.parser.Lit;
import oops.parser.Goal;
import oops.parser.Token;

/** Goal class for the product rule.
    @author Bernd Kuehl, Bernd.Kuehl@informatik.uni-osnabrueck.de
    @author Axel-Tobias Schreiner, axel@informatik.uni-osnabrueck.de
    @author Jan Kraneis, jkraneis@informatik.uni-osnabrueck.de
    @version 1.0
*/
public class product implements Goal {
  protected char op;
  protected Number result;

  /** shift method stores the operation.
  */
  public void shift(Lit sender, Object value) {
    op = sender.getBody().charAt(0);
  }

  /** shift method stores the value of the subtree
  */
  public void shift(Goal sender, Object value) {
    if (result == null) {
      result = (Number) value;
      return;
    }
    Number left = result, right = (Number) value;
    switch (op) {
      case '*':
        result = new Double(left.doubleValue() * right.doubleValue());
        break;
      case '/':
        result = new Double(left.doubleValue() / right.doubleValue());
        break;
    }
  }

  /** shift method does nothing.
  */
  public void shift(Token token, Object value) {}

  /** reduce method.
      @return the stored subtree
  */
  public Object reduce () {
    return result;
  }
}
