package tree;

import java.lang.ClassCastException;

import java.io.ObjectInputStream;
import java.util.Vector;

/** Executes arithmetic expressions from standard input.
    @author Bernd Kuehl, Bernd.Kuehl@informatik.uni-osnabrueck.de
    @author Axel-Tobias Schreiner, axel@informatik.uni-osnabrueck.de
    @author Jan Kraneis, jkraneis@informatik.uni-osnabrueck.de
    @version 1.0
*/
public class Go {
  /** loads a vector with Number elements from standard input
      and evaluates them.
      @param args ignored
    */
  public static void main (String args []) {
    try {
      ObjectInputStream in = new ObjectInputStream(System.in);
      Vector lines = (Vector)in.readObject();
      System.out.println("byte\tshort\tint\tlong\tfloat\tdouble");
      for (int i = 0; i < lines.size(); ++ i) {
	Number n = (Number)lines.elementAt(i);
	System.out.println(n.byteValue()+"\t"+n.shortValue()
				+"\t"+n.intValue()+"\t"+n.longValue()
				+"\t"+n.floatValue()+"\t"+n.doubleValue());
      }
    } catch (Exception e) { System.err.println(e);}
  }
}
