package tree;

import java.util.Vector;
import oops.parser.Goal;
import oops.parser.GoalAdapter;

/** Goal class for the expression rule.
    collect lines: [{ [ sum ] ';' }] in a Vector.
    @author Bernd Kuehl, Bernd.Kuehl@informatik.uni-osnabrueck.de
    @author Axel-Tobias Schreiner, axel@informatik.uni-osnabrueck.de
    @author Jan Kraneis, jkraneis@informatik.uni-osnabrueck.de
    @version 1.0
*/
public class expression extends GoalAdapter {
  /** stores a tree for each sum. */
  protected Vector lines = new Vector();

  /** presents result of reduction.
  @param sender just received reduce().
  @param node was created by sender.
  */
  public void shift (Goal sender, Object node) {
    lines.addElement(node);
  }

  /** concludes rule recognition.
    @return Vector of sum trees.
    */
  public Object reduce () {
    return lines;
  }
}
