package tree;

import oops.parser.Goal;
import oops.parser.GoalAdapter;

/** Goal class for the product rule.
    @author Bernd Kuehl, Bernd.Kuehl@informatik.uni-osnabrueck.de
    @author Axel-Tobias Schreiner, axel@informatik.uni-osnabrueck.de
    @author Jan Kraneis, jkraneis@informatik.uni-osnabrueck.de
    @version 1.0
*/
public class product extends GoalAdapter {
  
  /** shift method stores the value of the subtree
  */
  public void shift (Goal sender, Object node) {
    if (result == null) result = node;
    else result = ((build)sender).build(result, node);
  }
  
  /** Inner class implements tree building for multiplication
  */
  public static class mul extends build {
    public Object build (Object a, Object b) {
      return new Node.Mul((Number) a, (Number) b);
    }
  }
  
  /** Inner class implements tree building for division
  */
  public static class div extends build {
    public Object build (Object a, Object b) {
      return new Node.Div((Number) a, (Number) b);
    }
  }
}
