package tree;

import oops.parser.Goal;
import oops.parser.GoalAdapter;
import oops.parser.Lit;

/** Goal class for the term rule.
    @author Bernd Kuehl, Bernd.Kuehl@informatik.uni-osnabrueck.de
    @author Axel-Tobias Schreiner, axel@informatik.uni-osnabrueck.de
    @author Jan Kraneis, jkraneis@informatik.uni-osnabrueck.de
    @version 1.0
*/
public class term extends GoalAdapter {
  
  /** Inner class implements unary minus
  */
  public static class minus extends GoalAdapter {
    
    /** shift method stores the value of the subtree
    */
    public void shift (Goal sender, Object node) {
      result = new Node.Minus((Number) node);
    }
    /** does nothing
    */
    public void shift(Lit lit, Object node) {
      // ignore build object in node;
    }
  }
}
